classification
Title: configure script disables support for IPv6 on a system where IPv6 is disabled
Type: behavior Stage: resolved
Components: Versions: Python 3.4, Python 3.2, Python 3.3, Python 2.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: loewis, neologix, pitrou, python-dev, schmir
Priority: normal Keywords: easy, patch

Created on 2013-01-01 21:57 by schmir, last changed 2013-01-08 19:35 by neologix. This issue is now closed.

Files
File name Uploaded Description Edit
ipv6config.diff neologix, 2013-01-03 18:41 review
Messages (7)
msg178762 - (view) Author: Ralf Schmitt (schmir) Date: 2013-01-01 21:57
The configure script uses a runtime check to determine if IPv6 is working. If IPv6 is disabled system-wide via a kernel option on linux, the resulting python interpreter is compiled as if "--disable-ipv6" had been passed to the configure script.

This causes multiple issues:
- http://bugs.python.org/issue7735
- http://bugs.python.org/issue16208

Both of the above issues have been closed as wontfix, and I have been told to not use --disable-ipv6 and instead disable IPv6 system wide via a boot option. This is what I did, and now I have the same issue because the configure script has this runtime check...
msg178763 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2013-01-01 22:02
Indeed, I think the runtime check is misguided. If the system provides the required APIs for AF_INET6, then IPv6 support should be enabled regardless of whether the current system config allows to create an IPv6 socket or not.

Would you want to provide a patch for this? It's probably simple.
msg178955 - (view) Author: Ralf Schmitt (schmir) Date: 2013-01-03 15:44
> Would you want to provide a patch for this?

No, sorry.
msg178972 - (view) Author: Charles-François Natali (neologix) * (Python committer) Date: 2013-01-03 18:41
Here's a patch, tested with ipv6.disable=1.
msg179351 - (view) Author: Martin v. Löwis (loewis) * (Python committer) Date: 2013-01-08 13:41
LGTM.
msg179366 - (view) Author: Roundup Robot (python-dev) Date: 2013-01-08 19:08
New changeset 1d8effd379c3 by Charles-François Natali in branch '2.7':
Issue #16836: Enable IPv6 support even if IPv6 is disabled on the build host.
http://hg.python.org/cpython/rev/1d8effd379c3

New changeset d5df9ed118c5 by Charles-François Natali in branch '3.2':
Issue #16836: Enable IPv6 support even if IPv6 is disabled on the build host.
http://hg.python.org/cpython/rev/d5df9ed118c5

New changeset ebfd847bc15a by Charles-François Natali in branch '3.3':
Issue #16836: Enable IPv6 support even if IPv6 is disabled on the build host.
http://hg.python.org/cpython/rev/ebfd847bc15a

New changeset f7e563478349 by Charles-François Natali in branch 'default':
Issue #16836: Enable IPv6 support even if IPv6 is disabled on the build host.
http://hg.python.org/cpython/rev/f7e563478349
msg179367 - (view) Author: Charles-François Natali (neologix) * (Python committer) Date: 2013-01-08 19:35
Should be fixed now, thanks.
History
Date User Action Args
2013-01-08 19:35:32neologixsetstatus: open -> closed
resolution: fixed
messages: + msg179367

stage: commit review -> resolved
2013-01-08 19:08:19python-devsetnosy: + python-dev
messages: + msg179366
2013-01-08 13:42:00loewissetmessages: + msg179351
2013-01-07 17:56:04neologixsetnosy: + loewis
2013-01-04 17:41:37neologixsetstage: needs patch -> commit review
2013-01-03 18:41:52neologixsetfiles: + ipv6config.diff

nosy: + neologix
messages: + msg178972

keywords: + patch
2013-01-03 15:44:22schmirsetmessages: + msg178955
2013-01-01 22:02:59pitrousetversions: + Python 3.2, Python 3.3, Python 3.4
nosy: + pitrou

messages: + msg178763

keywords: + easy
stage: needs patch
2013-01-01 21:57:38schmircreate